<?php
/**
* phpPhotoEditor LIGHT
*
*    Dieses Script ist veroeffentlicht unter der GNU General Public License.
*    This Script is distributed under the GNU General Public License!
*
* @author       Werner Radisch <hausmeister@phpphotoeditor.de>
* @package      phpPhotoEditor LIGHT
* @copyright    2003 by Werner Radisch
* @version      1.0 (2004/08/05)
*/

if(!defined('isIncluded'))
{
    die('Access denied');
}

if(isset($_GET['p']) && is_numeric($_GET['p']))
{
    $start = $_GET['p']-1;
}
else
{
    $start = 0;
}


function getImgFiles($dir)
{
    global  $gifSup, $pngSup, $jpegSup, $lang;

    $wDir = opendir($dir);
    if(!$wDir)
    {    return FALSE;  }

    while($file = readdir($wDir))
    {
        if ($file=='.' || $file=='..' || is_dir($file))
        {
            continue;
        }
        $iInfo = @getimagesize($dir.$file);
        if(($iInfo[2] == 1 && $gifSup) || ($iInfo[2] == 2 && $pngSup) || ($iInfo[2] == 3 && $jpegSup))
        {
            $write = is_writable($dir.$file) ? 1 : 0;
            $size = round(filesize($dir.$file)/1024, 1);
            $lastedit = $lang == 'de' ? date('d.m.Y', filemtime($dir.$file)) : date('Y-m-d', filemtime($dir.$file));
            clearstatcache();
            
            $out[] = array(
                           'file'=>$file,
                           'w'=>$iInfo[0],
                           'h'=>$iInfo[1],
                           'size'=>$size,
                           'lastedit' => $lastedit,
                           'write'=>$write
                           );
        }
    }
    closedir($wDir);
    if(isset($out))
    {
        return $out;
    }
    else
    {
        return FALSE;
    }
}

function pager($start, $total, $pevImgPP)
{
    $ct = ceil($total/$pevImgPP);

    for($i=0; $i<$ct; $i++)
    {
        if(isset($_GET['p']) && $_GET['p'] == $i+1)
        {
            $pager[] = '<b>['.($i+1).']</b>';
        }
        else
        {
            if($i==0 && !isset($_GET['p']))
            {
                $pager[] = '<b>['.($i+1).']</b>';
            }
            else
            {
                $pager[] = '<a href="'.$_SERVER['PHP_SELF'].'?p='.($i+1).'">'.($i+1).'</a>';
            }
        }
    }
    return implode(' :: ', $pager);
}


function getDirList($dir, &$out)
{
    global $mainDir, $imgDir, $gifSup, $pngSup, $jpegSup, $lang;
    $handle = opendir($dir);
    while (false !== ($file = readdir($handle)))
    {
        if ($file=='.' || $file=='..')
        {
            continue;
        }

        if(is_dir($dir.$file))
        {
            getDirList($dir.$file.'/', $out);
        }
        else
        {
            if (is_array($out) && isset($out[$dir]))
                continue;
            $iInfo = getimagesize($dir.$file);
            if(($iInfo[2] == 1 && $gifSup) || ($iInfo[2] == 2 && $pngSup) || ($iInfo[2] == 3 && $jpegSup))
            {

                if(!stristr($dir, $mainDir.'/data/') && !stristr($dir, $mainDir.'/skin/') && !stristr($dir, $mainDir.'/watermark/'))
                {
                    $out[$dir] = substr(str_replace($mainDir, '', $dir),1,-1);
                }
            }
        }
    }
    closedir($handle);
    return $out;
}


$nix = '';
$dirList = getDirList($imgDir, $nix);
ksort($dirList);
$tplout['dirlisting'] = '<form action="'.$_SERVER['PHP_SELF'].'" method="post" style="display:inline;"><select name="myImgDir">';
$i=0;
foreach($dirList as $k=>$v)
{
    if($i==0) $startDir=$k;
    $tplout['dirlisting'] .= '<option value="'.$k.'">'.$v.'</option>';
    $i++;
}
$tplout['dirlisting'] .= '</select><input type="submit" value="go!"></form>';

if(isset($_POST['myImgDir']) && !empty($_POST['myImgDir']) && is_dir($_POST['myImgDir']))
{
    $_SESSION['readDir'] = $_POST['myImgDir'];
}

if(!isset($_SESSION['readDir']))
{
    $_SESSION['readDir'] = $startDir;
}

$nix = '';
$flist = getImgFiles($_SESSION['readDir']);
$tplout['activedir'] = substr(str_replace($mainDir, '', $_SESSION['readDir']),1,-1);

if($flist)
{

    $totalImg = count($flist);
    if($totalImg > $pevImgPP)
    {
        $tplout['pager'] = pager($start, $totalImg, $pevImgPP);
    }
    else
    {
        $tplout['pager'] = '';
    }


    if($start==0)
    {

        $end =  $pevImgPP;
        if($end > $totalImg)
        {
            $end = $totalImg;
        }
    }
    else
    {
        $start = $start * $pevImgPP;
        $end = $start + $pevImgPP;

        if($end > $totalImg)
        {
            $end = $totalImg;
        }
    }
    $tplImagelist = implode('',file($imagelistTpl));
    $tplout['imagelist'] = '';

    $replace['height'] = $pevImgW+20;
    for($i=$start; $i<$end; $i++)
    {
        $replace['title'] = htmlentities($flist[$i]['file']);
        $replace['dimension'] = $flist[$i]['w'].' x '.$flist[$i]['h'].' px';
        $replace['size'] = $flist[$i]['size'].' kb';
        $replace['link'] = '<a href="phphoto.php?f='.urlencode($flist[$i]['file']).'&amp;w='.$flist[$i]['write'].'">'.$mainText['workat'].'</a>';

        if($flist[$i]['h'] < $flist[$i]['w'])
        {
            $flist[$i]['h'] = round($flist[$i]['h']/($flist[$i]['w']/$pevImgW));
            $flist[$i]['w'] = $pevImgW;
        }
        elseif($flist[$i]['w'] < $flist[$i]['h'])
        {
            $flist[$i]['w'] = round($flist[$i]['w']/($flist[$i]['h']/$pevImgW));
            $flist[$i]['h'] = $pevImgW;
        }
        else
        {
            $flist[$i]['w'] = $pevImgW;
            $flist[$i]['h'] = $pevImgW;
        }
        $replace['image'] = '<img src="'.$mainUrl.str_replace($mainDir, '', $_SESSION['readDir']).$flist[$i]['file'].'?'.time().'" width="'.$flist[$i]['w'].'" height="'.$flist[$i]['h'].'" alt="'.$flist[$i]['file'].'" border="0">';
        $replace['lastedit'] = $mainText['lastedit'].': '.$flist[$i]['lastedit'];
        $tplout['imagelist'] .= str_replace(array('{{height}}','{{title}}', '{{dimension}}', '{{size}}', '{{link}}', '{{image}}', '{{lastedit}}'), $replace, $tplImagelist);
    }
    unset($flist);
}
$tplout = array_merge($tplout, $mainText);
$tplout['exitlink'] = $exitLink;
$mTpl=implode('',file($indexTpl));
foreach($tplout as $k=>$v)
{
    $mTpl = str_replace('{{'.$k.'}}', $v, $mTpl);
}
$mTpl = preg_replace("!\{\{([^\}]+)\}\}!", "", $mTpl);
echo $mTpl;
?>
