<?php
/**
* phpPhotoEditor LIGHT
*
*    Dieses Script ist veroeffentlicht unter der GNU General Public License.
*    This Script is distributed under the GNU General Public License!
*
* @author       Werner Radisch <hausmeister@phpphotoeditor.de>
* @package      phpPhotoEditor LIGHT
* @copyright    2003 by Werner Radisch
* @version      1.0 (2004/08/05)
*/

if(!defined('isIncluded'))
{
    die('Access denied');
}


$colNoClass = array("grey", "sepia", "invert", "darker", "lighter");

if(isset($_GET['f']))
{
    $baseimage = urldecode($_GET['f']);
}

function removeSingleDir($workDir)
{
    if(is_dir($workDir))
    {
        $dir = opendir($workDir);
        while($file = readdir($dir))
        {
            if($file != '.' && $file != '..')
                unlink($workDir.'/'.$file);
        }
        closedir($dir);
        rmdir($workDir);
    }
    clearstatcache();
}

function removeOldDir()
{
    global $mainWorkDir;

    $dir = opendir($mainWorkDir);
    while($file = readdir($dir))
    {
        if($file != '.' && $file != '..')
        {
            if((time()-filemtime($mainWorkDir.'/'.$file)) > 3600)
            {
                clearstatcache();
                removeSingleDir($mainWorkDir.'/'.$file);
            }
        }
    }
    closedir($dir);
}

function newAction($_no=NULL)
{
     global $doText, $degree, $workName, $workDir;

     if(is_null($_no))
     {
         if(!isset($_SESSION['img']['protocol']))
             $_SESSION['img']['protocol'][0] = 'Start';
         else
             $_SESSION['img']['protocol'][] = $doText[$_POST['action']].($_POST['action']=='rotate' ? $degree.'&deg;' : '');

         $oldImg = $workName.$_SESSION['img']['type'];
         $no = count($_SESSION['img']['protocol'])-1;
         $newImg = $workName.'.'.$no.$_SESSION['img']['type'];
     }
     else
     {
         $oldImg = $workName.'.'.$_no.$_SESSION['img']['type'];
         $newImg = $workName.$_SESSION['img']['type'];
     }

     return copy($workDir.'/'.$oldImg, $workDir.'/'.$newImg);
}



function splitName($_img, $_no)
{
    $end = substr($_img,strrpos($_img, '.'));
    $interName = substr($_img,0,strrpos($_img, '.'));
    if($noPos = strrpos($interName, '.'))
    {
        if(is_numeric(substr($interName,$noPos+1)))
            return substr($interName,0,$noPos).'.'.$_no.$end;
        else
            return $interName.'.'.$_no.$end;
    }
    else
    {
        return $interName.'.'.$_no.$end;
    }
}


function goBack($_no)
{
    global $workName, $workDir;

    $lastPos = count($_SESSION['img']['protocol']);
    $_SESSION['img']['redo'] = $_SESSION['img']['protocol'];
    if(newAction($_no))
    {
        $start = $_no+1;
        for($i=$start; $i < $lastPos; $i++)
        {
            unlink($workDir.'/'.$workName.'.'.$i.$_SESSION['img']['type']);
            $_SESSION['img']['protocol'][$i] = '';
            unset($_SESSION['img']['protocol'][$i]);
        }
    }
    else
        die('copy error');

    return TRUE;
}

removeOldDir();
if(isset($_SESSION['img']) && !file_exists($workDir.'/'.$workName.$_SESSION['img']['type']))
{
    $_SESSION['img'] = '';
    unset($_SESSION['img']);
    header('LOCATION: '.$_SERVER['PHP_SELF'].'?'.session_name().'='.session_id().'');
}

if(!isset($_SESSION['img']) || empty($_SESSION['img']))
{
    removeSingleDir($workDir);
    mkdir($workDir, 0755);
    chmod($workDir, 0777);

    if(!copy($_SESSION['readDir'].$baseimage, $workDir.'/'.$workName.substr($baseimage,strrpos($baseimage, '.'))))
    {
        die($mainText['restricted']);
    }

    $_SESSION['img']['realname'] = $baseimage;
    $_SESSION['img']['write'] = $_GET['w'];
    $_SESSION['img']['type'] = substr($baseimage,strrpos($baseimage, '.'));
}


if(isset($_GET['goback']))
{
    if(is_numeric($_GET['goback']))
        goBack($_GET['goback']);

    header('LOCATION: '.$_SERVER['PHP_SELF'].'?'.session_name().'='.session_id().'');
}


function getDirList($dir, &$out)
{
    global $mainDir, $imgDir, $gifSup, $pngSup, $jpegSup, $lang;
    $handle = opendir($dir);
    while (false !== ($file = readdir($handle)))
    {
        if ($file=='.' || $file=='..')
        {
            continue;
        }

        if(is_dir($dir.$file))
        {
            clearstatcache();
            getDirList($dir.$file.'/', $out);
        }
        else
        {
            if (is_array($out) && isset($out[$dir]))
                continue;
            $iInfo = getimagesize($dir.$file);
            if(($iInfo[2] == 1 && $gifSup) || ($iInfo[2] == 2 && $pngSup) || ($iInfo[2] == 3 && $jpegSup))
            {

                if(!stristr($dir, $mainDir.'/data/') && !stristr($dir, $mainDir.'/skin/') && !stristr($dir, $mainDir.'/watermark/'))
                {
                    $out[$dir] = substr(str_replace($mainDir, '', $dir),1,-1);
                }
            }
        }
    }
    closedir($handle);
    return $out;
}


$nix = '';
$dirList = getDirList($imgDir, $nix);
ksort($dirList);
$outDir = '<select name="myImgDir">';
foreach($dirList as $k=>$v)
{
    $outDir .= '<option value="'.$k.'"'.($k==$_SESSION['readDir'] ? ' selected' : '').'>'.$v.'</option>';
}
$outDir .= '</select>';



if(isset($_POST['save']))
{
    if(isset($_POST['newname']))
    {
        $newName = trim($_POST['newname']);
        $newName = str_replace(array('', '', '', ''), array('ae', 'oe', 'ue', 'ss'), strtolower($newName));
        if($_SESSION['img']['type'] == substr($newName,strrpos($newName, '.')))
        {
            $newName = substr($newName, 0, strrpos($newName, '.'));
        }
        if(strlen($newName) > 2)
        {
            $allowedSigns = array_merge(range(0,9), range('a','z'), array('-', '.', '_'));
            $newNewName = '';
            for($i=0; $i<strlen($newName); $i++)
            {
                if(in_array($newName[$i], $allowedSigns))
                {    $newNewName .= $newName[$i]; }
            }
            if(strlen($newNewName) > 2)
            {
                $newName = $newNewName.$_SESSION['img']['type'];
                if(strstr($_SESSION['img']['realname'], '/'))
                {
                    $newName = substr($_SESSION['img']['realname'], 0, strrpos($_SESSION['img']['realname'], '/')).'/'.$newName;
                }
            }
            else
            {
                header('LOCATION: '.$mainUrl.'/phphoto.php?'.session_name().'='.session_id().'');
            }
        }
        else
        {
            $newName = $_SESSION['img']['realname'];
        }
    }
    else
    {
        $newName = $_SESSION['img']['realname'];
    }

    $destDir = $_SESSION['readDir'];
    if(isset($_POST['myImgDir']) && !empty($_POST['myImgDir']) && is_dir($_POST['myImgDir']))
    {
        clearstatcache();
        $destDir = $_POST['myImgDir'];
        $_SESSION['readDir'] = $_POST['myImgDir'];
    }



    $do = @copy($workDir.'/'.$workName.$_SESSION['img']['type'], $destDir.$newName);
    if(!$do)
    {
        header('LOCATION: http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?'.session_name().'='.session_id().'&error=save');
    }
    $_SESSION['img'] = '';
    unset($_SESSION['img']);
    header('LOCATION: '.$mainUrl.'/index.php?'.session_name().'='.session_id().'');
}


if(isset($_GET['cl']) && $_GET['cl']== 1)
{
    $_SESSION['img'] = '';
    unset($_SESSION['img']);
    header('LOCATION: '.$mainUrl.'/index.php?'.session_name().'='.session_id().'');
}

if(isset($_POST['action']))
{
    if(!isset($_SESSION['img']['protocol']))
        newAction();

    if(!in_array($_POST['action'], $colNoClass))
    {
    require_once('func05.php');
    $img = &new image();
    $img->init($workDir.'/'.$workName.$_SESSION['img']['type'], $workDir.'/'.$workName.$_SESSION['img']['type'], 1);

    switch($_POST['action'])
    {
        case 'resize':
            $rw = (int)$_POST['rw'];
            $rh = (int)$_POST['rh'];
            $rw = $rw > 800 ? 800 : $rw;
            $rh = $rh > 800 ? 800 : $rh;
            $img->imgResizeClip($rw, $rh, $_POST['rztype']);
            break;
        case 'rotate':
            $degree = !empty($_POST['degfree']) ? (float)$_POST['degfree'] :  (float)$_POST['degfix'];
            if(empty($degree))
            {
               $img->error['rotate'] = 'empty degree';
               break;
            }
            else
            {
                $img->imgRotate($_POST['direct'], $degree);
            }
            break;
    }

    if(empty($img->error))
    {
        $img->imgOut();
        newAction();
    }
}
else
{
     require_once('func03.php');
     newAction();
}

}


$out = $ieditTxt;
$info = getimagesize($workDir.'/'.$workName.$_SESSION['img']['type']);
$out['dirlisting'] = $outDir;
$out['image'] = $workUrl.session_id().'/'.$workName.$_SESSION['img']['type'].'?'.time();
$out['iwidth'] = $info[0];
$out['iheight'] = $info[1];
$out['link'] = $_SERVER['PHP_SELF'];
$out['protocol'] = '';
$out['error'] = '';


if(isset($_REQUEST['error']))
{
    $out['error'] = '<div class="error">'.$errorTxt[$_REQUEST['error']].'</div>';
}


if(isset($_SESSION['img']['protocol']) && is_array($_SESSION['img']['protocol']))
{
    $i=0;
    $z = count($_SESSION['img']['protocol'])-1;
    foreach($_SESSION['img']['protocol'] as $k=>$v)
    {
        if($i == $z)
            $out['protocol'] .= '<li>'.$v.'</li>';
        else
            $out['protocol'] .= '<li class="protlist"><a href="'.$_SERVER['PHP_SELF'].'?goback='.$k.'">'.$v.'</a></li>';
        $i++;
    }
}
if(empty($out['protocol']))
{
    $out['protocol'] = '<li>---</li>';
}

$tpl = implode('', file($workTpl));
foreach($out as $k=>$v)
{
    $tpl=str_replace('{{'.$k.'}}', $v, $tpl);
}
echo $tpl;
?>
