<?php
/**
* phpPhotoEditor LIGHT
*
*    Dieses Script ist veroeffentlicht unter der GNU General Public License.
*    This Script is distributed under the GNU General Public License!
*
* @author       Werner Radisch <hausmeister@phpphotoeditor.de>
* @package      phpPhotoEditor LIGHT
* @copyright    2003 by Werner Radisch
* @version      1.0 (2004/08/05)
*/

if(!defined('isIncluded'))
{
    die('Access denied');
}


class image
{
    var $gdinfo = NULL;
    var $imgsrc = NULL;
    var $imgdest = NULL;
    var $imgWmSrc = NULL;      /
    var $imgnew = NULL;
    var $imgin  = NULL;
    var $imgout = NULL;
    var $imgwidth  = NULL;
    var $imgheight = NULL;
    var $thisimage=array();
    var $thisWmImg = array();
    var $imgquality = 100;
    var $imgwritefile = NULL;
    var $error = array();


    function image()
    {  }
  
    function init($_imgin, $_imgout=NULL, $_out=NULL)
    {
        if(!is_null($_out))
            $this->imgwritefile = $_out;

        if(!is_null($_imgout))
            $this->imgout = $_imgout;

        $this->imgin = $_imgin;
        $this->getGd();

        $this->getImgInfo();
        $this->getImgSrc();
        $this->colorsTotal = imagecolorstotal($this->imgsrc);
    }



    function imgResizeClip($_w, $_h, $_clip=0)
    {
        $_w = trim((int)$_w);
        $_h = trim((int)$_h);

        if(empty($_w) || !is_numeric($_w) || empty($_h) || !is_numeric($_h))
        {
            $this->error['imgResizeClip']='wrong size parameter (resize)';
            return FALSE;
        }

        $this->imgwidth = $_w;
        $this->imgheight = $_h;

        switch($_clip)
        {
            case 0:
                $size = $this->getImgClip();
                break;
            case 1:
                $size = $this->getImgResize();
                break;
            case 3:
                $size['new_w'] = $_w;
                $size['new_h'] = $_h;
                break;
        }

        $this->createImgSrc($_w, $_h);

        if(is_null($this->gdinfo))
        {
            $this->error['imgResizeClip']='no gd';
            return false;
        }
        elseif($this->gdinfo == 2)
            imagecopyresampled($this->imgdest, $this->imgsrc, 0, 0, 0, 0, $size['new_w'], $size['new_h'], $this->thisimage['x'],$this->thisimage['y']);
        else
            imagecopyresized($this->imgdest, $this->imgsrc, 0, 0, 0, 0, $size['new_w'], $size['new_h'], $this->thisimage['x'],$this->thisimage['y']);

        $this->switchImgSrc($_w, $_h);
    }

    function imgRotate($_direct, $_degree)
    {
        $_degree = $_degree%360;

        if(!$_degree)
        {    return FALSE; }

        if($_direct == 'cw')
        {    $_degree = 360 - $_degree; }

        if($this->gdinfo < 2)
        {
            if($_degree > 0 && $_degree <= 90)
            {
                $_degree = 90;
            }
            elseif($_degree > 90 && $_degree <= 180)
            {
                $_degree = 180;
            }
            elseif($_degree > 180 && $_degree <= 270)
            {
                $_degree = 270;
            }
            else
            {
                return true;
            }
            $this->getImgRotateGD1_flat($_degree);
            return true;
        }
            

        if($_degree == 180)
        {
            $this->imgdest=imagerotate($this->imgsrc, 180, 180);
            $this->switchImgSrc($this->thisimage['x'], $this->thisimage['y']);
        }
        elseif($_degree == 90 || $_degree == 270)
        {
            $maxXY = max($this->thisimage['x'], $this->thisimage['y']);
            $x = $this->thisimage['y'];
            $y = $this->thisimage['x'];
            $this->createImgSrc($maxXY, $maxXY);
            imagecopy($this->imgdest, $this->imgsrc, 0, 0, 0, 0, $this->thisimage['x'], $this->thisimage['y']);
            imagedestroy($this->imgsrc);
            $this->imgsrc = imagerotate($this->imgdest, $_degree, 180);
            imagedestroy($this->imgdest);
            $this->createImgSrc($x, $y);

            if($_degree==90)
                imagecopy($this->imgdest, $this->imgsrc, 0, 0, 0, $maxXY-$y, $x, $y);
            else
                imagecopy($this->imgdest, $this->imgsrc, 0, 0, $maxXY-$x, 0, $x, $y);

            $this->switchImgSrc($x, $y);
        }
        return TRUE;
    }
 
    function getGd()
    {
        ob_start();
        phpinfo();
        $gd_info = ob_get_contents();
        ob_end_clean();

        preg_match('!\nGD Version(.*?)\n!is',strip_tags($gd_info),$regs);
        if(isset($regs[1]))
        {
            if(strpos($regs[1], "2.")!==false)
                $this->gdinfo = 2;
            else
                $this->gdinfo = 1;
        }
    }

    function createImgSrc($_w, $_h)
    {
        if(is_null($this->gdinfo))
        {
            $this->error['createImgSrc']='no gd support';
            return false;
        }
        elseif($this->gdinfo > 1)
        {
            $this->imgdest = imagecreatetruecolor($_w, $_h);
        }
        else
        {
            $this->imgdest = imagecreate($_w, $_h);
            }

        return TRUE;
    }
  

   function createNewImgSrc($_w, $_h)
    {
        if(is_null($this->gdinfo))
        {
            $this->error['createNewImgSrc']='no gd support';
            return false;
        }
        elseif($this->gdinfo > 1)
        {
            $this->imgsrc = imagecreatetruecolor($_w, $_h);
        }
        else
        {
            $this->imgsrc = imagecreate($_w, $_h);
        }
        return TRUE;
    }
 
    function getImgSrc($_src=NULL)
    {
        $type = is_null($_src) ? $this->thisimage['type'] : $this->thisWmImg['type'];

        switch($type)
        {
            case 'gif':
                if(is_null($_src))
                    $this->imgsrc = imagecreatefromgif($this->imgin);
                else
                    $this->imgWmSrc = imagecreatefromgif($_src);
		        break;
	
            case 'png':
                if(is_null($_src))
                    $this->imgsrc = imagecreatefrompng($this->imgin);
                else
                    $this->imgWmSrc = imagecreatefrompng($_src);
		        break;
		    case 'jpeg':
                if(is_null($_src))
                    $this->imgsrc = imagecreatefromjpeg($this->imgin);
                else
                    $this->imgWmSrc = imagecreatefromjpeg($_src);
		        break;
        }
    }

    function hexColorToRGB($_hex)
    {
        $col['red'] = 100;
        $col['green'] = 100;
        $col['blue'] = 100;
        if(preg_match( "![#]?([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})!i", $_hex, $ret ) )
        {
            $col['red'] = hexdec( $ret[1] );
            $col['green'] = hexdec( $ret[2] );
            $col['blue'] = hexdec( $ret[3] );
        }
        return $col;
    }

    function setImgColor($r, $g, $b)
    {
        if(is_null($this->imgsrc))
        {
            $this->error['setImgColor']='no image source';
            return false;
        }

        imagecolorallocate($this->imgsrc,$r,$g,$b);
    }

    function getLightness($_r, $_g, $_b)
    {
        $kmin = min($_r/255,$_g/255,$_b/255);
        $kmax = max($_r/255,$_g/255,$_b/255);

        return floor(($kmax+$kmin)/2*100);
    }

    function getImgInfo($_src=NULL)
    {
        if(is_null($_src))
            $imginfo = getimagesize($this->imgin);
        else
            $imginfo = getimagesize($_src);


        switch($imginfo[2])
        {
            case 1:
                if(is_null($_src))
		            $this->thisimage['type'] = "gif";
                else
                    $this->thisWmImg['type'] = "gif";
		        break;
		    case 2:
                if(is_null($_src))
		            $this->thisimage['type'] = "jpeg";
                else
                    $this->thisWmImg['type'] = "jpeg";
		        break;
		    case 3:
                if(is_null($_src))
		            $this->thisimage['type'] = "png";
                else
                    $this->thisWmImg['type'] = "png";
      	        break;
        }

        if(is_null($_src))
        {
            $this->thisimage['x'] = $imginfo[0];
            $this->thisimage['y'] = $imginfo[1];
        }
        else
        {
            $this->thisWmImg['x'] = $imginfo[0];
            $this->thisWmImg['y'] = $imginfo[1];
        }

    }

    function switchImgSrc($_w, $_h)
    {
        imagedestroy($this->imgsrc);

        $this->createNewImgSrc($_w, $_h);

        imagecopy($this->imgsrc, $this->imgdest, 0, 0, 0, 0, $_w, $_h);
        imagedestroy($this->imgdest);
    }
 
    function imgOut()
    {
        if(is_null($this->imgwritefile))
        {
            switch($this->thisimage['type'])
            {
                case "png":
                case "gif":
                    header("Content-Type: image/png");
                    imagepng($this->imgsrc);
                    break;
                case "jpeg":
                    header("Content-Type: image/jpeg");
                    imagejpeg($this->imgsrc,"",$this->imgquality);
                    break;
            }
        }
        else
        {
            switch($this->thisimage['type'])
            {
                 case "png":
                 case "gif":
                     imagepng($this->imgsrc,$this->imgout);
                     break;
                 case "jpeg":
                 imagejpeg($this->imgsrc,$this->imgout,$this->imgquality);
                 break;
            }
        }
        imagedestroy($this->imgsrc);
    }


    function getImgResize()
    {
        if($this->thisimage['x'] > $this->thisimage['y'])
        {
            $this->imgwidth = $size['new_w'] =  ceil($this->thisimage['x']*($this->imgheight/$this->thisimage['y']));
            $size['new_h'] = $this->imgheight;
        }
        elseif($this->thisimage['y'] > $this->thisimage['x'])
        {
            $this->imgheight = $size['new_h'] =  ceil($this->thisimage['y']*($this->imgwidth/$this->thisimage['x']));
            $size['new_w'] = $this->imgwidth;
        }
        else
        {
            $size['new_w'] = $this->imgwidth;
            $size['new_h'] = $this->imgheight;
        }
        return $size;
    }

    function getImgClip()
    {
        if((int)$_POST['rh'] > (int)$_POST['rw'])
        {
            $size['new_w'] = ceil($this->thisimage['x']*((int)$_POST['rh']/$this->thisimage['y']));
            $size['new_h'] = (int)$_POST['rh'];
        }
        elseif((int)$_POST['rw'] > (int)$_POST['rh'])
        {
            $size['new_h'] = ceil($this->thisimage['y']*((int)$_POST['rw']/$this->thisimage['x']));
            $size['new_w'] = (int)$_POST['rw'];
        }
        else
        {
            $size['new_w'] = (int)$_POST['rw'];
            $size['new_h'] = (int)$_POST['rh'];
        }
        return $size;
    }

    function getImgRotateGD1_flat($_degree)
    {
         switch($_degree)
         {
            case 90:
            case 270:
               $this->createImgSrc($this->thisimage['y'], $this->thisimage['x']);
               break;
            case 180:
               $this->createImgSrc($this->thisimage['x'], $this->thisimage['y']);
               break;
         }

        if($_degree == 90 || $_degree == 180 || $_degree == 270)
        {
            for($i=0; $i<imagecolorstotal($this->imgsrc); $i++)
            {
                  $c = @imageColorsForIndex($this->imgsrc, $i);
                  imagecolorallocate($this->imgdest, $c['red'], $c['green'], $c['blue']);
            }

                for($x=0; $x<$this->thisimage['x']; $x++)
                {
                    for($y=0; $y<$this->thisimage['y']; $y++)
                    {
                         $c = imagecolorsforindex($this->imgdest,imagecolorat($this->imgsrc, $x, $y));
                         $i = imagecolorexact($this->imgdest,  $c['red'], $c['green'], $c['blue']);
                         switch($_degree)
                         {
                            case 90:
                                imagesetpixel($this->imgdest,  $y, $this->thisimage['x']-$x-1,  $i);
                                break;
                            case 270:
                                imagesetpixel($this->imgdest, $this->thisimage['y']-$y-1, $x,  $i);
                                break;
                            case 180:
                                imagesetpixel($this->imgdest, $this->thisimage['x']-$x-1, $this->thisimage['y']-$y-1, $i);
                                break;
                         }
                    }
                }
            switch($_degree)
            {
                case 90:
                case 270:
                    $this->switchImgSrc($this->thisimage['y'], $this->thisimage['x']);
                    break;
                case 180:
                    $this->switchImgSrc($this->thisimage['x'], $this->thisimage['y']);
                    break;
            }
        }
    }


    function getImgNewSizeGD1($_degree)
    {
        $out['vx'] = ceil(sin(deg2rad($_degree))*$this->thisimage['y']);
        $out['vy'] = ceil(cos(deg2rad($_degree))*$this->thisimage['y']);
        
        $out['y'] = $out['vy'] + ceil(sin(deg2rad($_degree))*$this->thisimage['x']);
        $out['x'] = $out['vx'] + ceil(cos(deg2rad($_degree))*$this->thisimage['x']);
        
        return $out;

    }
}

?>
